;
;	Symbolic defintions for some ASCII characters
;
EOS	EQU	0	;Printed string terminator
BELL	EQU	07O	;ASCII BEL (CONTROL-G)
CTRLC	EQU	03O	;ASCII ETX (CONTROL-C)
TAB	EQU	11O	;ASCII TAB (CONTROL-I)
LF	EQU	12O	;ASCII LINE FEED (CTRL-J)
FF	EQU	14O	;ASCII FORM FEED (CTRL-L)
CR	EQU	15O	;ASCII CARRIAGE RETURN (CTRL-M)
XON	EQU	21O	;THE THE ASCII CHARACTER USED FOR XON
XOFF	EQU	23O	;THE THE ASCII CHARACTER USED FOR XOFF
ESC	EQU	33O	;ASCII ESCAPE
SUBT	EQU	32O	;ASCII SUB (CTRL-Z)
DEL	EQU	177O	;ASCII DELETE (RUBOUT)
DEFESC	EQU	31	;<CLEAR> KEY ON KEY BOARD
MAXPKT	EQU	'~'-' '+2O	;MAXIMUM SIZE OF A PACKET.
DRPSIZ	EQU	5EH	;DEFAULT RECEIVE PACKET SIZE.
DSPSIZ	EQU	20H	;DEFAULT SEND PACKET SIZE.
DSTIME	EQU	15	;DEFAULT SEND TIME OUT INTERVAL.
DRTIME	EQU	10	;DEFAULT RECEIVE TIME OUT INTERVAL.
DSPAD	EQU	00H	;DEFAULT SEND PADDING.
DRPAD	EQU	00H	;DEFAULT RECEIVE PADDING.
DSPADC	EQU	00H	;DEFAULT SEND PADDING CHAR.
DRPADC	EQU	00H	;DEFAULT RECEIVE PADDING CHAR.
DSEOL	EQU	CR	;DEFAULT SEND EOL CHAR.
DREOL	EQU	CR	;DEFAULT RECEIVE EOL CHAR.
DSQUOT	EQU	'#'	;DEFAULT SEND QUOTE CHAR.
DRQUOT	EQU	'#'	;DEFAULT RECEIVE QUOTE CHAR.
DSCHKT	EQU	'1'	;DEFAULT CHECKSUM TYPE
SOH	EQU	01H	;START OF HEADER CHAR.
CMKEY	EQU	01H	;PARSE A KEYWORD.
CMIFI	EQU	02H	;PARSE AN INPUT FILE SPEC.
CMOFI	EQU	03H	;PARSE AN OUTPUT FILE SPEC.
CMCFM	EQU	04H	;PARSE A CONFIRM.
CMTXT	EQU	05H	;PARSE TEXT.
CMNUM	EQU	06H	;PARSE ASCII DECIMAL STRING
CMIFIN	EQU	10H	;PARSE AN INPUT FILE SPEC
