;	m4mac/asm
*LIST	OFF
PUTHL	MACRO	#P1
	LD	(HL),#P1
	INC	HL
	ENDM
;
;	Protocol switch macro
;
;	Expansion is something like:
;
;	CP	'D'
;	JR	NZ,SWAA
;	CALL	SDATA
;	JP	PROTO
;SWAA
;
SWITCH	MACRO	#P1,#P2
	CP	#P1
	JR	NZ,SW?
	CALL	#P2
	JP	PROTO
SW?
	ENDM
;
TOCHAR	MACRO
	ADD	A,32
	ENDM
;
STROUT	MACRO	#P1
	LD	DE,#P1
	CALL	PRTSTR
	ENDM
;
SPACKET	MACRO	#P1
	LD	A,#P1
	CALL	SPACK
	JP	ABORT
	ENDM
;
RPACKET	MACRO
	CALL	RPACK
	JP	QUIT
	ENDM
;
NSTATE	MACRO	#P1
	LD	A,#P1
	LD	(STATE),A
	ENDM
;
IFANOT	MACRO	#P1,#P2
	CP	#P1
	JR	NZ,#P2
	ENDM
;
IFALT	MACRO	#P1,#P2
	CP	#P1
	JR	C,#P2
	ENDM
;
IFAGE	MACRO	#P1,#P2
	CP	#P1
	JR	NC,#P2
	ENDM
;
IFA	MACRO	#P1,#P2
	CP	#P1
	JR	Z,#P2
	ENDM
;
IFZ	MACRO	#P1
	OR	A
	JR	Z,#P1
	ENDM
;
GENCASE	MACRO	#P1,#P2
	LD	A,#P2
	LD	(FLDLEN),A
	LD	A,#P1
	JP	GENCMD
	ENDM
;
GETHL	MACRO	#P1
	INC	HL
	LD	#P1,(HL)
	ENDM
;
ADDPUT	MACRO	#P1
	LD	A,(#P1)
	CALL	TCHPUT
	ENDM
;
SRPACK	MACRO	#P1
	LD	A,#P1
	CALL	SPACK
	JP	ABORT
	RPACKET
	ENDM
;
GETCRCTAB	MACRO
	LD	C,A
	LD	HL,CRCTAB
	ADD	HL,BC
	ADD	HL,BC
	ENDM
;
XORATHL	MACRO	#P1
	LD	A,#P1
	XOR	(HL)
	LD	#P1,A
	ENDM
;
CHKWKEY	MACRO	#P1
	IFA	#P1,INCHR5
	ENDM
;
IFNZ	MACRO	#P1
	OR	A
	JR	NZ,#P1
	ENDM
;
SETFLG	MACRO	#P1
	CALL	ONOFF
	LD	(#P1),A
	JP	KERMIT
	ENDM
;
SHOFFON	MACRO	#P1
	LD	A,(#P1)
	CALL	COFFON
	JP	NEWLIN
	ENDM
;
FOFFON	MACRO	#P1
	LD	A,(#P1)
	CALL	COFFON
	CALL	NEWLIN
	ENDM
;
SHRSTAT	MACRO	#P1,#P2
	FORMAT	#P1,SRSTRLEN
	LD	A,(#P2)
	CALL	ANOUT
	CALL	NEWLIN
	ENDM
;
SHSSTAT	MACRO	#P1,#P2
	FORMAT	#P1,SRSTRLEN
	LD	A,(#P2)
	CALL	ANOUT
	CALL	NEWLIN
	ENDM
;
DOSVC	MACRO	#P1
	LD	A,#P1
	RST	28H
	LD	(XERRNO),A
	RET
	ENDM
;
FORMAT	MACRO	#P1,#P2
	LD	HL,#P2
	LD	DE,#P1
	CALL	LEFTPAD
	ENDM
;
TRLOG	MACRO	#P1,#P2
	LD	HL,#P1
	CALL	OUTLOG
	JP	#P2
	ENDM
*LIST	ON
